<template>
    <Header />

    <main class="w-[1390px] m-0 m-auto">

        <div class="mt-5 mb-12">
            <p class="font-light cursor-pointer">
                <RouterLink to="/">Главная</RouterLink> > <RouterLink to="/styles">Стили</RouterLink> > {{ sets.titleSets
                }}
            </p>
        </div>
        <div class="grid grid-cols-2 gap-16 mb-32">
            <div>
                <swiper :loop="true" :autoplay="{ delay: 1000 }" :spaceBetween="10" :navigation="false"
                    :thumbs="{ swiper: thumbsSwiper }" :modules="modules" class="mySwiper2">
                    <swiper-slide v-for="(img, index) in sets.coverImageName" :key="index">
                        <img :src="`https://client.st.com.tm/uploads/sets/resize/` + img" />
                    </swiper-slide>
                </swiper>
                <swiper @swiper="setThumbsSwiper" :loop="true" :autoplay="{ delay: 1000 }" :spaceBetween="10"
                    :slidesPerView="4" :freeMode="true" :watchSlidesProgress="true" :modules="modules" class="mySwiper">
                    <swiper-slide v-for="(img, index) in sets.coverImageName" :key="index">
                        <img :src="`https://client.st.com.tm/uploads/sets/resize/` + img" />
                    </swiper-slide>
                </swiper>
            </div>


            <div>
                <p class="text-medium text-2xl mb-9">{{ sets.titleSets }}</p>

                <p class="mb-6 font-light tetx-[#28303F]">Мы подчеркнули размеры используемые на данном интерьере.</p>

                <div v-for="(painting, index) in sets.paintingsName" :key="index"
                    class="flex items-center justify-between w-[80%] mb-5">
                    <div class="w-[50%] flex justify-center">
                        <img :src="`https://client.st.com.tm/uploads/paintings/resize/` + painting.coverImageName.filename"
                            alt="" :class="{
                                'w-[9.375rem]': painting.orientation === 'vertical',
                                'w-[11.75rem]': painting.orientation === 'horizontal'
                            }">
                    </div>
                    <div class="flex flex-col gap-2 w-[50%]">
                        <select class="border p-2 text-sm" v-model="selectedPrintSize[index]">
                            <option disabled :value="null">Выберете размер печати</option>
                            <option v-for="(printSize, sizeIndex) in painting.printSizePost" :key="sizeIndex"
                                :value="printSize.prSize">
                                <span>{{ printSize.prSize }}см</span> - <span>{{ printSize.pricePost }} ман.</span>
                            </option>
                        </select>

                        <select class="border p-2 text-sm" v-model="selectedFrame[index]"
                            @change="selectFrame($event.target.selectedIndex, index)">
                            <option disabled :value="null">Выберете раму</option>
                            <option value="">Без рамы</option>
                            <option v-for="(frame, frameIndex) in filteredFrames[index]" :key="frameIndex"
                                :value="frame.frameName">
                                {{ frame.frameName }} - ({{ frame.frameSize }}) - {{ frame.frameСost }} ман.
                            </option>
                        </select>

                        <button @click="addItemToBasket(index)" class="p-2 border text-sm bg-[#7D92AA] text-white">
                            Добавить в корзину | {{ calculateTotalPrice(index, index) }} ман.
                        </button>
                    </div>
                </div>


                <RouterLink :to="{ name: 'basket' }">
                    <button class="py-3 px-12 text-white bg-[#7D92AA] font-semibold">Перейти в корзину</button>
                </RouterLink>
            </div>
        </div>

        <div class="flex justify-center mb-14">
            <img src="../../assets//icon/gift.svg" alt="">
        </div>


        <div class="mb-16">
            <p class="mb-10 text-center">Похожие постеры</p>
            <div class="w-full grid grid-cols-4 gap-12 mb-20">
                <SetCard set-page="setStylesPage" v-for="(set, index) in styleSet" :key="index" :set="set" />
            </div>
        </div>

        <div class="flex justify-center mb-16">
            <img src="../../assets/add.svg" alt="">
        </div>
    </main>
    <Footer />
</template>

<script>
import axios from 'axios';
import Header from '../Header.vue';

import SetCard from "../SetCard.vue"
import Footer from "../Footer.vue"

import { Swiper, SwiperSlide } from 'swiper/vue';
import 'swiper/css';
import 'swiper/css/free-mode';
import 'swiper/css/navigation';
import 'swiper/css/thumbs';
import { FreeMode, Navigation, Thumbs } from "swiper/modules"

export default {
    props: {
        setName: {
            type: String,
            required: true
        }
    },
    components: {
        Header,
        Swiper,
        SwiperSlide,
        Footer,
        SetCard
    },
    data() {
        return {
            sets: [],
            frames: [],
            thumbsSwiper: null,
            modules: [FreeMode, Navigation, Thumbs],
            setPrice: 0,
            selectedPrintSize: [],
            selectedFrame: [],
            styleSet: [],
        }
    },
    mounted() {
        this.fetchData()
    },
    methods: {
        async fetchData() {
            try {
                const id = this.$route.params.id;
                const response = await axios.get(`https://client.st.com.tm/api/sets/${id}`)
                this.sets = response.data

                const responseFrames = await axios.get(`https://client.st.com.tm/api/frames`)
                this.frames = responseFrames.data

                this.selectedPrintSize = Array(this.sets.paintingsName.length).fill(null);
                this.selectedFrame = Object.keys(this.frames).map(() => null);

                const responseSet = await axios.get("https://client.st.com.tm/api/sets")
                const sets = responseSet.data

                this.styleSet = sets.filter(set => {
                    return set.catalogName && set.catalogName.includes("Стили");
                });
            } catch (error) {
                console.log(error)
            }
        },
        setThumbsSwiper(swiper) {
            this.thumbsSwiper = swiper;
        },
        calculateTotalPrice(printSizeIndex, frameIndex) {
            let totalPrice = 0;
            const printSize = this.selectedPrintSize[printSizeIndex];
            const frame = this.selectedFrame[frameIndex];

            if (printSize) {
                const selectedPrint = this.sets.paintingsName[printSizeIndex].printSizePost.find(
                    size => size.prSize === printSize
                );
                totalPrice += selectedPrint.pricePost;
            }

            if (frame && frame !== "") {
                if (this.filteredFrames[printSizeIndex] && this.filteredFrames[printSizeIndex][frameIndex]) {
                    const selectedFrame = this.filteredFrames[printSizeIndex][frameIndex];
                    if (selectedFrame && selectedFrame.frameСost) {
                        totalPrice += parseFloat(selectedFrame.frameСost);
                    }
                }
            }

            return totalPrice;
        },
        selectFrame(frameIndex, printSizeIndex) {
            const selectedFrameName = this.filteredFrames[printSizeIndex][frameIndex].frameName;
            this.selectedFrame[printSizeIndex] = selectedFrameName;
        },
        addItemToBasket(index) {
            const totalPrice = this.calculateTotalPrice(index, index);
            const printSize = this.selectedPrintSize[index];
            const painting = this.sets.paintingsName[index];

            const item = {
                id: painting._id,
                title: painting.title,
                size: printSize,
                cost: totalPrice,
                img: painting.coverImageName.filename,
                quantity: painting.quantity,
            };

            let basket = JSON.parse(localStorage.getItem('basket')) || [];

            basket.push(item);

            localStorage.setItem('basket', JSON.stringify(basket));
        }
    },
    computed: {
        filteredFrames() {
            return this.selectedPrintSize.map((selectedSize, index) => {
                if (!selectedSize) return [];

                const selectedPrint = this.sets.paintingsName[index].printSizePost.find(size => size.prSize === selectedSize);
                if (!selectedPrint) return [];

                const selectedFrameSize = selectedPrint.prSize;

                let framesWithMatchingSize = this.frames.filter(frame => {
                    return frame.frameSize === selectedFrameSize;
                });

                return framesWithMatchingSize;
            });
        }

    }
}

</script>

<style scoped>
.swiper {
    width: 100%;
    height: 100%;
}

.swiper-slide {
    text-align: center;
    font-size: 18px;
    /* background: #fff; */

    /* Center slide text vertically */
    display: flex;
    justify-content: center;
    align-items: center;
}

.swiper-slide img {
    display: block;
    width: 100%;
    height: 100%;
    object-fit: cover;
}


.swiper {
    width: 100%;
    height: 300px;
    margin-left: auto;
    margin-right: auto;
}

.swiper-slide {
    background-size: cover;
    background-position: center;
}

.mySwiper2 {
    height: 80%;
    width: 100%;
}

.mySwiper {
    height: 20%;
    box-sizing: border-box;
    padding: 10px 0;
}

.mySwiper .swiper-slide {
    width: 25%;
    height: 100%;
    opacity: 0.4;
}

.mySwiper .swiper-slide-thumb-active {
    opacity: 1;
}

.swiper-slide img {
    display: block;
    width: 100%;
    height: 100%;
    object-fit: cover;
}
</style>